Index: trunk/source/Lib/TLibDecoder/TDecTop.cpp
===================================================================
--- trunk/source/Lib/TLibDecoder/TDecTop.cpp	(revision 1085)
+++ trunk/source/Lib/TLibDecoder/TDecTop.cpp	(revision 1124)
@@ -726,4 +726,9 @@
 
 #endif
+#if HHI_TOOL_PARAMETERS_I2_J0107
+#if H_3D
+  m_apcSlicePilot->init3dToolParameters();
+#endif
+#endif
   pps->setSPS(sps);
   pps->setNumSubstreams(pps->getEntropyCodingSyncEnabledFlag() ? ((sps->getPicHeightInLumaSamples() + sps->getMaxCUHeight() - 1) / sps->getMaxCUHeight()) * (pps->getNumTileColumnsMinus1() + 1) : 1);
@@ -1082,4 +1087,9 @@
     pcSlice->getTempRefPicLists( m_cListPic, m_refPicSetInterLayer0, m_refPicSetInterLayer1, tempRefPicLists, usedAsLongTerm, numPocTotalCurr);
     pcSlice->setRefPicList     ( tempRefPicLists, usedAsLongTerm, numPocTotalCurr, true ); 
+
+#if SEC_ARP_VIEW_REF_CHECK_J0037 || SEC_DBBP_VIEW_REF_CHECK_J0037
+    pcSlice->setDefaultRefView();
+#endif
+
 #if H_3D_ARP
     pcSlice->setARPStepNum(m_ivPicLists);
@@ -1234,5 +1244,9 @@
   TComVPS* vps = m_parameterSetManagerDecoder.getPrefetchedVPS( 0 ); 
   assert( vps != 0 );
+#if HHI_TOOL_PARAMETERS_I2_J0107
+  m_cEntropyDecoder.decodeSPS( sps );
+#else
   m_cEntropyDecoder.decodeSPS( sps, vps->getViewIndex( m_layerId ), ( vps->getDepthId( m_layerId ) == 1 ) );
+#endif
 #else
   m_cEntropyDecoder.decodeSPS( sps );
Index: trunk/source/Lib/TLibDecoder/TDecTop.h
===================================================================
--- trunk/source/Lib/TLibDecoder/TDecTop.h	(revision 1085)
+++ trunk/source/Lib/TLibDecoder/TDecTop.h	(revision 1124)
@@ -83,8 +83,10 @@
 #endif
 
+#if !LGE_DDD_REMOVAL_J0042_J0030
 #if H_3D_DDD
   Int getCodedScale( Int iBaseView, Int iCureView){ return m_aaiCodedScale[ iBaseView ][ iCureView ];}
   Int getCodedOffset( Int iBaseView, Int iCureView){ return m_aaiCodedOffset[ iBaseView ][ iCureView ];}
   UInt getCamParsCodedPrecision(){ return m_vps->getCamParPrecision(); }
+#endif
 #endif
 
Index: trunk/source/Lib/TLibEncoder/TEncCavlc.cpp
===================================================================
--- trunk/source/Lib/TLibEncoder/TEncCavlc.cpp	(revision 1085)
+++ trunk/source/Lib/TLibEncoder/TEncCavlc.cpp	(revision 1124)
@@ -638,8 +638,12 @@
 }
 
+#if HHI_TOOL_PARAMETERS_I2_J0107
+Void TEncCavlc::codeSPS( TComSPS* pcSPS )
+#else
 #if H_3D
 Void TEncCavlc::codeSPS( TComSPS* pcSPS, Int viewIndex, Bool depthFlag )
 #else
 Void TEncCavlc::codeSPS( TComSPS* pcSPS )
+#endif
 #endif
 {
@@ -842,5 +846,9 @@
   if ( pcSPS->getSps3dExtensionFlag() )
   {
+#if HHI_TOOL_PARAMETERS_I2_J0107
+    codeSPS3dExtension( pcSPS ); 
+#else
     codeSPSExtension2( pcSPS, viewIndex, depthFlag  ); 
+#endif
   }
 
@@ -863,4 +871,8 @@
   WRITE_CODE( pcPPS->getPpsScalingListRefLayerId( ), 6, "pps_scaling_list_ref_layer_id" );
   WRITE_UVLC( 0, "num_ref_loc_offsets" );
+#if H_MV_HLS_FIX
+  WRITE_FLAG( 0 , "colour_mapping_enabled_flag" );
+#endif
+
 }
 
@@ -868,8 +880,38 @@
 
 #if H_3D
+#if HHI_TOOL_PARAMETERS_I2_J0107
+Void TEncCavlc::codeSPS3dExtension( TComSPS* pcSPS )
+{
+  TComSps3dExtension* sps3dExt = pcSPS->getSps3dExtension();
+  for( Int d = 0; d  <=  1; d++ )
+  {
+    WRITE_FLAG( sps3dExt->getIvMvPredFlag( d ) ? 1 : 0 , "iv_mv_pred_flag" );
+    WRITE_FLAG( sps3dExt->getIvMvScalingFlag( d ) ? 1 : 0 , "iv_mv_scaling_flag" );
+    if( d  ==  0 )
+    {
+      WRITE_UVLC( sps3dExt->getLog2SubPbSizeMinus3( d ), "log2_sub_pb_size_minus3" );
+      WRITE_FLAG( sps3dExt->getIvResPredFlag( d ) ? 1 : 0 , "iv_res_pred_flag" );
+      WRITE_FLAG( sps3dExt->getDepthRefinementFlag( d ) ? 1 : 0 , "depth_refinement_flag" );
+      WRITE_FLAG( sps3dExt->getViewSynthesisPredFlag( d ) ? 1 : 0 , "view_synthesis_pred_flag" );
+      WRITE_FLAG( sps3dExt->getDepthBasedBlkPartFlag( d ) ? 1 : 0 , "depth_based_blk_part_flag" );
+    }
+    else 
+    {
+      WRITE_FLAG( sps3dExt->getMpiFlag( d ) ? 1 : 0 , "mpi_flag" );
+      WRITE_UVLC( sps3dExt->getLog2MpiSubPbSizeMinus3( d ), "log2_mpi_sub_pb_size_minus3" );
+      WRITE_FLAG( sps3dExt->getIntraContourFlag( d ) ? 1 : 0 , "intra_contour_flag" );
+      WRITE_FLAG( sps3dExt->getIntraSdcWedgeFlag( d ) ? 1 : 0 , "intra_sdc_wedge_flag" );
+      WRITE_FLAG( sps3dExt->getQtPredFlag( d ) ? 1 : 0 , "qt_pred_flag" );
+      WRITE_FLAG( sps3dExt->getInterSdcFlag( d ) ? 1 : 0 , "inter_sdc_flag" );
+      WRITE_FLAG( sps3dExt->getIntraSingleFlag( d ) ? 1 : 0 , "intra_single_flag" );
+    }
+  }
+}
+#else
 Void TEncCavlc::codeSPSExtension2( TComSPS* pcSPS, Int viewIndex, Bool depthFlag )
 {
 
 }
+#endif
 #endif
 
@@ -969,7 +1011,13 @@
   codeVPSExtension( pcVPS );                           
 #if H_3D
-  WRITE_FLAG( 1,                     "vps_extension2_flag" );
+  WRITE_FLAG( 1,                     "vps_extension2_flag" );  
+#if HHI_VPS_3D_EXTENSION_I3_J0107
+  WRITE_FLAG( 1,                     "vps_3d_extension_flag" );
+  m_pcBitIf->writeAlignOne();      
+  codeVPS3dExtension( pcVPS ); 
+#else
   m_pcBitIf->writeAlignOne();      
   codeVPSExtension2( pcVPS ); 
+#endif
   WRITE_FLAG( 0,                     "vps_extension3_flag" );
 #else
@@ -1141,5 +1189,9 @@
   for( Int i = 1; i < pcVPS->getNumOutputLayerSets( ); i++ )
   {
+#if H_MV_HLS_FIX
+    if( pcVPS->getNumLayerSets() > 2 && i >= pcVPS->getNumLayerSets( ) )    
+#else
     if( i >= pcVPS->getNumLayerSets( ) )    
+#endif
     {      
       WRITE_CODE( pcVPS->getLayerSetIdxForOlsMinus1( i ), pcVPS->getLayerSetIdxForOlsMinus1Len( i ) ,      "layer_set_idx_for_ols_minus1[i]" );
@@ -1211,5 +1263,5 @@
 
   WRITE_FLAG( pcVPS->getMaxOneActiveRefLayerFlag( ) ? 1 : 0, "max_one_active_ref_layer_flag" );
-#if H_MV_HLS7_GEN
+#if H_MV_HLS7_GEN || H_MV_HLS_FIX
   WRITE_FLAG( pcVPS->getVpsPocLsbAlignedFlag( ) ? 1 : 0 , "vps_poc_lsb_aligned_flag" );
 #endif
@@ -1261,4 +1313,7 @@
     codeVPSVUI( pcVPS ); 
   }     
+#if H_MV_HLS_FIX
+  else
+#endif
   {
     TComVPSVUI* pcVPSVUI = pcVPS->getVPSVUI( ); 
@@ -1575,6 +1630,11 @@
 
 #if H_3D
+#if HHI_VPS_3D_EXTENSION_I3_J0107
+Void TEncCavlc::codeVPS3dExtension( TComVPS* pcVPS )
+#else
 Void TEncCavlc::codeVPSExtension2( TComVPS* pcVPS )
+#endif
 { 
+#if !HHI_TOOL_PARAMETERS_I2_J0107
   for( Int i = 1; i <= pcVPS->getMaxLayersMinus1(); i++ )
   {
@@ -1619,7 +1679,11 @@
         WRITE_FLAG( pcVPS->getInterSDCFlag( i ) ? 1 : 0, "depth_inter_SDC_flag" );
 #endif
+#if MTK_SINGLE_DEPTH_VPS_FLAG_J0060
+        WRITE_FLAG( pcVPS->getSingleDepthModeFlag( i ) ? 1 : 0, "single_depth_mode_flag" );
+#endif
       }
     }  
   }
+#endif
   WRITE_UVLC( pcVPS->getCamParPrecision(), "cp_precision" );
   for (UInt viewIndex=1; viewIndex<pcVPS->getNumViews(); viewIndex++)
@@ -1725,5 +1789,5 @@
     }
     pcSlice->checkCrossLayerBlaFlag( ); 
-#if !H_MV_HLS7_GEN
+#if !H_MV_HLS7_GEN && !H_MV_HLS_FIX
     if ( pcSlice->getPPS()->getNumExtraSliceHeaderBits() > esb )
     {
@@ -1887,8 +1951,24 @@
     Bool interLayerPredLayerIdcPresentFlag = false; 
     Int layerId = pcSlice->getLayerId(); 
+#if HHI_DEPENDENCY_SIGNALLING_I1_J0107
+#if H_3D
+    if( pcSlice->getLayerId() > 0 && !vps->getAllRefLayersActiveFlag() && vps->getNumRefListLayers( layerId ) > 0 )
+#else
     if( pcSlice->getLayerId() > 0 && !vps->getAllRefLayersActiveFlag() && vps->getNumDirectRefLayers( layerId ) > 0 )
+#endif
+#else
+    if( pcSlice->getLayerId() > 0 && !vps->getAllRefLayersActiveFlag() && vps->getNumDirectRefLayers( layerId ) > 0 )
+#endif
     {   
       WRITE_FLAG( pcSlice->getInterLayerPredEnabledFlag( ) ? 1 : 0 , "inter_layer_pred_enabled_flag" );
+#if HHI_DEPENDENCY_SIGNALLING_I1_J0107
+#if H_3D
+      if( pcSlice->getInterLayerPredEnabledFlag() && vps->getNumRefListLayers( layerId ) > 1 )
+#else
       if( pcSlice->getInterLayerPredEnabledFlag() && vps->getNumDirectRefLayers( layerId ) > 1 )
+#endif
+#else
+      if( pcSlice->getInterLayerPredEnabledFlag() && vps->getNumDirectRefLayers( layerId ) > 1 )
+#endif
       {            
         if( !vps->getMaxOneActiveRefLayerFlag())  
@@ -1896,5 +1976,13 @@
           WRITE_CODE( pcSlice->getNumInterLayerRefPicsMinus1( ), pcSlice->getNumInterLayerRefPicsMinus1Len( ), "num_inter_layer_ref_pics_minus1" );
         }
+#if HHI_DEPENDENCY_SIGNALLING_I1_J0107
+#if H_3D
+        if ( pcSlice->getNumActiveRefLayerPics() != vps->getNumRefListLayers( layerId ) )
+#else
         if ( pcSlice->getNumActiveRefLayerPics() != vps->getNumDirectRefLayers( layerId ) )
+#endif
+#else
+        if ( pcSlice->getNumActiveRefLayerPics() != vps->getNumDirectRefLayers( layerId ) )
+#endif
         {        
           interLayerPredLayerIdcPresentFlag = true; 
@@ -2037,5 +2125,9 @@
     }
 #if H_3D_IC
+#if HHI_DEPENDENCY_SIGNALLING_I1_J0107
+    else if( pcSlice->getViewIndex() && ( pcSlice->getSliceType() == P_SLICE || pcSlice->getSliceType() == B_SLICE ) && !pcSlice->getIsDepth() && vps->getNumRefListLayers( layerId ) > 0 )
+#else
     else if( pcSlice->getViewIndex() && ( pcSlice->getSliceType() == P_SLICE || pcSlice->getSliceType() == B_SLICE ) && !pcSlice->getIsDepth() && vps->getNumDirectRefLayers( layerId ) > 0 )
+#endif
     {
       WRITE_FLAG( pcSlice->getApplyIC() ? 1 : 0, "slice_ic_enable_flag" );
@@ -2046,4 +2138,5 @@
     }
 #endif
+#if !MTK_SINGLE_DEPTH_VPS_FLAG_J0060
 #if H_3D_SINGLE_DEPTH
     if(pcSlice->getIsDepth())
@@ -2052,4 +2145,5 @@
     }
 #endif
+#endif
 #if H_3D_IV_MERGE
     assert(pcSlice->getMaxNumMergeCand()<=MRG_MAX_NUM_CANDS_MEM);
@@ -2060,4 +2154,11 @@
     {
 #if H_3D_IV_MERGE
+#if HHI_TOOL_PARAMETERS_I2_J0107      
+#if ALGIN_J0107_J0059
+      WRITE_UVLC( ( ( pcSlice->getMpiFlag( ) || pcSlice->getIvMvPredFlag( ) || pcSlice->getViewSynthesisPredFlag( ) ) ? MRG_MAX_NUM_CANDS_MEM : MRG_MAX_NUM_CANDS ) - pcSlice->getMaxNumMergeCand(), "five_minus_max_num_merge_cand");
+#else
+      WRITE_UVLC( ( ( pcSlice->getMpiFlag( ) || pcSlice->getIvMvPredFlag( ) ) ? MRG_MAX_NUM_CANDS_MEM : MRG_MAX_NUM_CANDS ) - pcSlice->getMaxNumMergeCand(), "five_minus_max_num_merge_cand");
+#endif
+#else
       if(pcSlice->getIsDepth())
       {
@@ -2069,6 +2170,12 @@
       {
         Bool ivMvPredFlag = pcSlice->getVPS()->getIvMvPredFlag( pcSlice->getLayerIdInVps() ) ;
+#if MTK_MRG_LIST_SIZE_CLEANUP_J0059
+        Bool vspFlag = pcSlice->getVPS()->getViewSynthesisPredFlag( pcSlice->getLayerIdInVps() ) ;
+        WRITE_UVLC( ( ivMvPredFlag || vspFlag ? MRG_MAX_NUM_CANDS_MEM : MRG_MAX_NUM_CANDS ) - pcSlice->getMaxNumMergeCand(), "five_minus_max_num_merge_cand");
+#else
         WRITE_UVLC( ( ivMvPredFlag ? MRG_MAX_NUM_CANDS_MEM : MRG_MAX_NUM_CANDS ) - pcSlice->getMaxNumMergeCand(), "five_minus_max_num_merge_cand");
-      }
+#endif
+      }
+#endif
 #else
       WRITE_UVLC(MRG_MAX_NUM_CANDS - pcSlice->getMaxNumMergeCand(), "five_minus_max_num_merge_cand");
@@ -2136,7 +2243,9 @@
   {
     // Derive the value of PocMsbValRequiredFlag
+#if !H_MV_HLS_FIX
     pcSlice->setPocMsbValRequiredFlag( pcSlice->getCraPicFlag() || pcSlice->getBlaPicFlag()
                                           /* || related to vps_poc_lsb_aligned_flag */
                                           );
+#endif
 
     // Determine value of SH extension length.
@@ -2156,5 +2265,9 @@
 
 
+#if H_MV_HLS_FIX
+    if( !pcSlice->getPocMsbValRequiredFlag() &&  pcSlice->getVPS()->getVpsPocLsbAlignedFlag() )
+#else
     if( !pcSlice->getPocMsbValRequiredFlag() /* TODO &&  pcSlice->getVPS()->getVpsPocLsbAlignedFlag() */ )
+#endif
     {
       shExtnLengthInBit++;    // For poc_msb_val_present_flag
@@ -2219,5 +2332,9 @@
     pcSlice->checkPocLsbVal(); 
 
+#if H_MV_HLS_FIX
+    if( !pcSlice->getPocMsbValRequiredFlag() &&  pcSlice->getVPS()->getVpsPocLsbAlignedFlag()  )
+#else
     if( !pcSlice->getPocMsbValRequiredFlag() /* TODO &&  pcSlice->getVPS()->getVpsPocLsbAlignedFlag() */ )
+#endif
     {
       WRITE_FLAG( pcSlice->getPocMsbValPresentFlag( ) ? 1 : 0 , "poc_msb_val_present_flag" );
Index: trunk/source/Lib/TLibEncoder/TEncCavlc.h
===================================================================
--- trunk/source/Lib/TLibEncoder/TEncCavlc.h	(revision 1085)
+++ trunk/source/Lib/TLibEncoder/TEncCavlc.h	(revision 1124)
@@ -99,7 +99,16 @@
 #endif
 #if H_3D
+#if HHI_VPS_3D_EXTENSION_I3_J0107
+  Void  codeVPS3dExtension       ( TComVPS* pcVPS ); 
+#else
   Void  codeVPSExtension2       ( TComVPS* pcVPS ); 
+#endif
+#if HHI_TOOL_PARAMETERS_I2_J0107
+  Void  codeSPS3dExtension      ( TComSPS* pcSPS );
+  Void  codeSPS                 ( TComSPS* pcSPS );
+#else
   Void  codeSPSExtension2       ( TComSPS* pcSPS, Int viewIndex, Bool depthFlag  ); 
   Void  codeSPS                 ( TComSPS* pcSPS, Int viewIndex, Bool depthFlag );
+#endif
 #else
   Void  codeSPS                 ( TComSPS* pcSPS );
Index: trunk/source/Lib/TLibEncoder/TEncCfg.h
===================================================================
--- trunk/source/Lib/TLibEncoder/TEncCfg.h	(revision 1085)
+++ trunk/source/Lib/TLibEncoder/TEncCfg.h	(revision 1124)
@@ -392,4 +392,5 @@
   Double    m_dDispCoeff;
 #endif
+#if !HHI_TOOL_PARAMETERS_I2_J0107
 #if H_3D_ARP
   UInt      m_uiUseAdvResPred;
@@ -400,8 +401,10 @@
   Int      m_iSubPUMPILog2Size;
 #endif
+#endif
 #if H_3D_IC
   Bool      m_bUseIC;
   Bool      m_bUseICLowLatencyEnc;
 #endif
+#if !HHI_TOOL_PARAMETERS_I2_J0107
 #if H_3D_INTER_SDC
   bool      m_bInterSDC;
@@ -409,17 +412,23 @@
 #if H_3D_DBBP
   Bool      m_bUseDBBP;
+#endif
 #endif
   //====== Depth Intra Modes ======
 #if H_3D_DIM
   Bool      m_useDMM;
+#if !HHI_TOOL_PARAMETERS_I2_J0107
   Bool      m_useIVP;
+#endif
   Bool      m_useSDC;
   Bool      m_useDLT;
 #endif
+#if !HHI_TOOL_PARAMETERS_I2_J0107
 #if H_3D_SINGLE_DEPTH
   Bool      m_useSingleDepthMode;
 #endif
+
 #if H_3D_IV_MERGE
   Bool      m_useMPI;
+#endif
 #endif
 #if H_3D_QTLPC
@@ -497,4 +506,5 @@
   Void      setMaxTempLayer                 ( Int maxTempLayer )            { m_maxTempLayer = maxTempLayer;      }
 
+#if !HHI_TOOL_PARAMETERS_I2_J0107
 #if H_3D_ARP
   UInt       getUseAdvRP                    ( )              { return m_uiUseAdvResPred; }
@@ -510,4 +520,5 @@
   Void       setSubPUMPILog2Size            (Int u)          { m_iSubPUMPILog2Size = u;   }     
 #endif
+#endif
 #if H_3D_IC
   Void       setUseIC                       ( Bool bVal )    { m_bUseIC = bVal; }
@@ -516,4 +527,5 @@
   Bool       getUseICLowLatencyEnc          ()               { return m_bUseICLowLatencyEnc; }
 #endif
+#if !HHI_TOOL_PARAMETERS_I2_J0107
 #if H_3D_INTER_SDC
   Void       setInterSDCEnable              ( Bool bVal )    { m_bInterSDC = bVal; }
@@ -523,4 +535,5 @@
   Void       setUseDBBP                     ( Bool  b )      { m_bUseDBBP   = b; }
   Bool       getUseDBBP()                                    { return m_bUseDBBP;     }
+#endif
 #endif
   //======== Transform =============
@@ -932,4 +945,6 @@
   Void setFrameOnlyConstraintFlag(Bool b) { m_frameOnlyConstraintFlag = b; }
 #if H_3D
+
+  // Only flags that are not in the SPS3dExtension should go here. 
   /// 3D Tools 
 
@@ -976,23 +991,30 @@
   Bool      getUseDMM                       ()        { return m_useDMM; }
   Void      setUseDMM                       ( Bool b) { m_useDMM = b;    }
+#if !HHI_TOOL_PARAMETERS_I2_J0107
   Bool      getUseIVP                       ()        { return m_useIVP; }
   Void      setUseIVP                       ( Bool b) { m_useIVP = b;    }
+#endif
   Bool      getUseSDC                       ()        { return m_useSDC; }
   Void      setUseSDC                       ( Bool b) { m_useSDC = b;    }
+
   Bool      getUseDLT                       ()        { return m_useDLT; }
   Void      setUseDLT                       ( Bool b) { m_useDLT = b;    }
 #endif
+#if !HHI_TOOL_PARAMETERS_I2_J0107
 #if H_3D_SINGLE_DEPTH
   Void       setUseSingleDepthMode          ( Bool bVal )    { m_useSingleDepthMode = bVal; }
   Bool       getUseSingleDepthMode          ()               { return m_useSingleDepthMode; }
 #endif
+#endif
 #if H_3D_QTLPC
   Void      setUseQTL                       ( Bool b ) { m_bUseQTL = b;    }
   Bool      getUseQTL                       ()         { return m_bUseQTL; }
 #endif
+#if !HHI_TOOL_PARAMETERS_I2_J0107
 #if H_3D_IV_MERGE
   Void      setUseMPI                       ( Bool b ) { m_useMPI = b;    }
   Bool      getUseMPI                       ()         { return m_useMPI; }
 #endif
+#endif
 #endif // H_3D
 };
Index: trunk/source/Lib/TLibEncoder/TEncCu.cpp
===================================================================
--- trunk/source/Lib/TLibEncoder/TEncCu.cpp	(revision 1085)
+++ trunk/source/Lib/TLibEncoder/TEncCu.cpp	(revision 1124)
@@ -409,6 +409,10 @@
 
 #if H_3D_QTLPC
-  TComVPS *vps            = pcPic->getSlice(0)->getVPS();
+#if HHI_TOOL_PARAMETERS_I2_J0107
+  Bool  bLimQtPredFalg    = pcPic->getSlice(0)->getQtPredFlag(); 
+#else
+    TComVPS *vps            = pcPic->getSlice(0)->getVPS();
   Bool  bLimQtPredFalg    = vps->getLimQtPredFlag(pcPic->getSlice(0)->getLayerId()); 
+#endif
   TComPic *pcTexture      = rpcBestCU->getSlice()->getTexturePic();
 
@@ -566,5 +570,9 @@
       {
 #if H_3D_ARP && H_3D_IV_MERGE
+#if HHI_TOOL_PARAMETERS_I2_J0107
+        if( rpcTempCU->getSlice()->getIvResPredFlag() || rpcTempCU->getSlice()->getIvMvPredFlag() )
+#else
         if( rpcTempCU->getSlice()->getVPS()->getUseAdvRP(rpcTempCU->getSlice()->getLayerId()) || rpcTempCU->getSlice()->getVPS()->getIvMvPredFlag(rpcTempCU->getSlice()->getLayerId()) )
+#endif
 #else 
 #if H_3D_ARP
@@ -590,5 +598,9 @@
 #endif 
 #if H_3D_NBDV_REF
+#if HHI_TOOL_PARAMETERS_I2_J0107
+          if( rpcTempCU->getSlice()->getDepthRefinementFlag() )
+#else
           if(rpcTempCU->getSlice()->getVPS()->getDepthRefinementFlag( rpcTempCU->getSlice()->getLayerIdInVps()))
+#endif
             DvInfo.bDV = rpcTempCU->getDisMvpCandNBDV(&DvInfo, true);
           else
@@ -605,5 +617,9 @@
       }
 #if  H_3D_FAST_TEXTURE_ENCODING
+#if SEC_ARP_VIEW_REF_CHECK_J0037 || SEC_DBBP_VIEW_REF_CHECK_J0037
+      if(rpcTempCU->getSlice()->getViewIndex() && !rpcTempCU->getSlice()->getIsDepth() && rpcTempCU->getSlice()->getDefaultRefViewIdxAvailableFlag() )
+#else
       if(rpcTempCU->getSlice()->getViewIndex() && !rpcTempCU->getSlice()->getIsDepth())
+#endif
       {
         PartSize ePartTemp = rpcTempCU->getPartitionSize(0);
@@ -668,5 +684,13 @@
           
 #if H_3D_DBBP
+#if SEC_DBBP_VIEW_REF_CHECK_J0037
+#if HHI_TOOL_PARAMETERS_I2_J0107
+          if( rpcTempCU->getSlice()->getDepthBasedBlkPartFlag() && rpcTempCU->getSlice()->getDefaultRefViewIdxAvailableFlag() )
+#else
+          if( m_pcEncCfg->getUseDBBP() && rpcTempCU->getSlice()->getDefaultRefViewIdxAvailableFlag() )
+#endif
+#else
           if( m_pcEncCfg->getUseDBBP() )
+#endif
           {
             xCheckRDCostInterDBBP( rpcBestCU, rpcTempCU, false );
@@ -715,5 +739,13 @@
 #if H_3D_SINGLE_DEPTH
     rpcTempCU->initEstData( uiDepth, iMinQP, isAddLowestQP  );
+#if MTK_SINGLE_DEPTH_VPS_FLAG_J0060
+#if ALIGN_J0060_J0107
+    if( rpcBestCU->getSlice()->getIntraSingleFlag() )
+#else
+    if(rpcBestCU->getSlice()->getVPS()->getSingleDepthModeFlag(rpcBestCU->getSlice()->getLayerIdInVps()))
+#endif
+#else
     if(rpcBestCU->getSlice()->getApplySingleDepthMode())
+#endif
     {
       xCheckRDCostSingleDepth( rpcBestCU, rpcTempCU, SIZE_2Nx2N );
@@ -1869,9 +1901,10 @@
 
 #endif
-
+#if !LGE_DDD_REMOVAL_J0042_J0030
 #if H_3D_DDD
     Int iDDDCand = rpcTempCU->getUseDDDCandIdx(); 
     UChar ucDDDepth = rpcTempCU->getDDTmpDepth();
     rpcTempCU->setUseDDD( false, 0, uhDepth );
+#endif
 #endif
 
@@ -1908,4 +1941,5 @@
           rpcTempCU->setVSPFlagSubParts( vspFlag[uiMergeCand], 0, 0, uhDepth );
 #endif
+#if !LGE_DDD_REMOVAL_J0042_J0030
 #if H_3D_DDD
           if( rpcTempCU->getSlice()->getIsDepth() && rpcTempCU->getSlice()->getViewIndex() != 0 && iDDDCand == uiMergeCand )
@@ -1918,4 +1952,5 @@
               rpcTempCU->setUseDDD( false, 0, 0, uhDepth );
           }
+#endif
 #endif
 #if H_3D_SPIVMP
@@ -2021,5 +2056,9 @@
           xCheckBestMode(rpcBestCU, rpcTempCU, uhDepth);
 #if H_3D_INTER_SDC
+#if HHI_TOOL_PARAMETERS_I2_J0107
+          if( rpcTempCU->getSlice()->getInterSdcFlag() && !uiNoResidual )
+#else
           if( rpcTempCU->getSlice()->getVPS()->getInterSDCFlag( rpcTempCU->getSlice()->getLayerIdInVps() ) && rpcTempCU->getSlice()->getIsDepth() && !uiNoResidual )
+#endif
           {
             Double dOffsetCost[3] = {MAX_DOUBLE,MAX_DOUBLE,MAX_DOUBLE};
@@ -2093,5 +2132,9 @@
       {
 #if H_3D_INTER_SDC
+#if HHI_TOOL_PARAMETERS_I2_J0107
+        if( rpcTempCU->getSlice()->getInterSdcFlag() )
+#else
         if( rpcTempCU->getSlice()->getVPS()->getInterSDCFlag( rpcTempCU->getSlice()->getLayerIdInVps() ) )
+#endif
         {
           bestIsSkip = !rpcBestCU->getSDCFlag( 0 ) && ( rpcBestCU->getQtRootCbf(0) == 0 );
@@ -2169,5 +2212,7 @@
   UChar uhDepth = rpcTempCU->getDepth( 0 );
 #if H_3D_ARP
+#if !HHI_TOOL_PARAMETERS_I2_J0107
   Int iLayerId    = rpcTempCU->getSlice()->getLayerId();
+#endif
   Bool bFirstTime = true;
   Int nARPWMax    = rpcTempCU->getSlice()->getARPStepNum() - 1;
@@ -2180,5 +2225,9 @@
   for( Int nARPW = 0; nARPW <= nARPWMax; nARPW++ )
   {
+#if HHI_TOOL_PARAMETERS_I2_J0107
+    if( !bFirstTime && rpcTempCU->getSlice()->getIvResPredFlag() )
+#else
     if( bFirstTime == false && rpcTempCU->getSlice()->getVPS()->getUseAdvRP( iLayerId ) )
+#endif
     {
       rpcTempCU->initEstData( rpcTempCU->getDepth(0), rpcTempCU->getQP(0),bTransquantBypassFlag );      
@@ -2204,6 +2253,8 @@
   rpcTempCU->setPartSizeSubParts  ( ePartSize,  0, uhDepth );
   rpcTempCU->setPredModeSubParts  ( MODE_INTER, 0, uhDepth );
+#if !LGE_DDD_REMOVAL_J0042_J0030
 #if H_3D_DDD
   rpcTempCU->setUseDDD( false, 0, uhDepth );
+#endif
 #endif
 
@@ -2284,5 +2335,9 @@
   xCheckBestMode(rpcBestCU, rpcTempCU, uhDepth);
 #if H_3D_INTER_SDC
+#if HHI_TOOL_PARAMETERS_I2_J0107
+  if( rpcTempCU->getSlice()->getInterSdcFlag() && ePartSize == SIZE_2Nx2N)
+#else
   if( rpcTempCU->getSlice()->getVPS()->getInterSDCFlag( rpcTempCU->getSlice()->getLayerIdInVps() ) && rpcTempCU->getSlice()->getIsDepth() && ePartSize == SIZE_2Nx2N)
+#endif
   {
     Double dOffsetCost[3] = {MAX_DOUBLE,MAX_DOUBLE,MAX_DOUBLE};
Index: trunk/source/Lib/TLibEncoder/TEncEntropy.cpp
===================================================================
--- trunk/source/Lib/TLibEncoder/TEncEntropy.cpp	(revision 1085)
+++ trunk/source/Lib/TLibEncoder/TEncEntropy.cpp	(revision 1124)
@@ -78,4 +78,11 @@
 }
 
+#if HHI_TOOL_PARAMETERS_I2_J0107
+Void TEncEntropy::encodeSPS( TComSPS* pcSPS )
+{
+  m_pcEntropyCoderIf->codeSPS( pcSPS );
+  return;
+}
+#else
 #if H_3D
 Void TEncEntropy::encodeSPS( TComSPS* pcSPS, Int viewIndex, Bool depthFlag )
@@ -91,4 +98,5 @@
 }
 #endif
+#endif
 
 Void TEncEntropy::encodeCUTransquantBypassFlag( TComDataCU* pcCU, UInt uiAbsPartIdx, Bool bRD )
@@ -122,13 +130,26 @@
 Void TEncEntropy::encodeSingleDepthMode( TComDataCU* pcCU, UInt uiAbsPartIdx, Bool bRD )
 {
+#if ALIGN_J0060_J0107
+  if(!pcCU->getSlice()->getIntraSingleFlag() )
+  {
+    return;
+  }
+#else
   if ( !pcCU->getSlice()->getIsDepth() )
   {
     return;
   }
+#if MTK_SINGLE_DEPTH_VPS_FLAG_J0060
+  if(!pcCU->getSlice()->getVPS()->getSingleDepthModeFlag(pcCU->getSlice()->getLayerIdInVps()))
+  {
+     return;
+  }
+#else
   if(!pcCU->getSlice()->getApplySingleDepthMode())
   {
      return;
   }
-  
+#endif
+#endif
   if( bRD )
   {
@@ -268,5 +289,13 @@
   
 #if H_3D_DBBP
+#if SEC_DBBP_VIEW_REF_CHECK_J0037
+#if HHI_TOOL_PARAMETERS_I2_J0107
+  if( pcCU->getSlice()->getDepthBasedBlkPartFlag() && (pcCU->getPartitionSize(uiAbsPartIdx) == SIZE_2NxN || pcCU->getPartitionSize(uiAbsPartIdx) == SIZE_Nx2N) && pcCU->getWidth(uiAbsPartIdx) > 8 && pcCU->getSlice()->getDefaultRefViewIdxAvailableFlag() )
+#else
+  if( pcCU->getSlice()->getVPS()->getUseDBBP(pcCU->getSlice()->getLayerIdInVps()) && (pcCU->getPartitionSize(uiAbsPartIdx) == SIZE_2NxN || pcCU->getPartitionSize(uiAbsPartIdx) == SIZE_Nx2N) && pcCU->getWidth(uiAbsPartIdx) > 8 && pcCU->getSlice()->getDefaultRefViewIdxAvailableFlag() )
+#endif
+#else
   if( pcCU->getSlice()->getVPS()->getUseDBBP(pcCU->getSlice()->getLayerIdInVps()) && (pcCU->getPartitionSize(uiAbsPartIdx) == SIZE_2NxN || pcCU->getPartitionSize(uiAbsPartIdx) == SIZE_Nx2N) && pcCU->getWidth(uiAbsPartIdx) > 8 )
+#endif
   {
     encodeDBBPFlag(pcCU, uiAbsPartIdx, bRD);
@@ -780,6 +809,11 @@
 Void TEncEntropy::encodeSDCFlag( TComDataCU* pcCU, UInt uiAbsPartIdx, Bool bRD )
 {
+#if HHI_TOOL_PARAMETERS_I2_J0107
+  if( ( !pcCU->isIntra( uiAbsPartIdx ) && !pcCU->getSlice()->getInterSdcFlag() ) || 
+    ( pcCU->isIntra( uiAbsPartIdx ) && !pcCU->getSlice()->getIntraSdcWedgeFlag() ) )
+#else
   if( ( !pcCU->isIntra( uiAbsPartIdx ) && !pcCU->getSlice()->getVPS()->getInterSDCFlag( pcCU->getSlice()->getLayerIdInVps() ) ) || 
     ( pcCU->isIntra( uiAbsPartIdx ) && !pcCU->getSlice()->getVPS()->getVpsDepthModesFlag( pcCU->getSlice()->getLayerIdInVps() ) ) )
+#endif
   {
     return;
Index: trunk/source/Lib/TLibEncoder/TEncEntropy.h
===================================================================
--- trunk/source/Lib/TLibEncoder/TEncEntropy.h	(revision 1085)
+++ trunk/source/Lib/TLibEncoder/TEncEntropy.h	(revision 1124)
@@ -69,8 +69,12 @@
 
   virtual Void  codeVPS                 ( TComVPS* pcVPS )                                      = 0;
+#if HHI_TOOL_PARAMETERS_I2_J0107
+  virtual Void  codeSPS                 ( TComSPS* pcSPS )                                      = 0;
+#else
 #if !H_3D
   virtual Void  codeSPS                 ( TComSPS* pcSPS )                                      = 0;
 #else
   virtual Void  codeSPS                 ( TComSPS* pcSPS, Int viewIndex, Bool depthFlag )       = 0;
+#endif
 #endif
   virtual Void  codePPS                 ( TComPPS* pcPPS )                                      = 0;
@@ -165,8 +169,12 @@
   Void encodeVPS               ( TComVPS* pcVPS);
   // SPS
+#if HHI_TOOL_PARAMETERS_I2_J0107
+  Void encodeSPS               ( TComSPS* pcSPS );
+#else
 #if H_3D
   Void encodeSPS               ( TComSPS* pcSPS, Int viewIndex, Bool depthFlag );
 #else
   Void encodeSPS               ( TComSPS* pcSPS );
+#endif
 #endif
   Void encodePPS               ( TComPPS* pcPPS );
Index: trunk/source/Lib/TLibEncoder/TEncGOP.cpp
===================================================================
--- trunk/source/Lib/TLibEncoder/TEncGOP.cpp	(revision 1085)
+++ trunk/source/Lib/TLibEncoder/TEncGOP.cpp	(revision 1124)
@@ -880,5 +880,13 @@
 
     TComVPS*           vps = pcSlice->getVPS();     
+#if HHI_DEPENDENCY_SIGNALLING_I1_J0107
+#if H_3D
+    Int numDirectRefLayers = vps    ->getNumRefListLayers( getLayerId() ); 
+#else
     Int numDirectRefLayers = vps    ->getNumDirectRefLayers( getLayerId() ); 
+#endif
+#else
+    Int numDirectRefLayers = vps    ->getNumDirectRefLayers( getLayerId() ); 
+#endif
     GOPEntry gopEntry      = m_pcCfg->getGOPEntry( (pcSlice->getRapPicFlag() && getLayerId() > 0) ? MAX_GOP : iGOPid );     
     
@@ -893,5 +901,13 @@
           pcSlice->setNumInterLayerRefPicsMinus1( gopEntry.m_numActiveRefLayerPics - 1 ); 
         }
+#if HHI_DEPENDENCY_SIGNALLING_I1_J0107
+#if H_3D
+        if ( gopEntry.m_numActiveRefLayerPics != vps->getNumRefListLayers( getLayerId() ) )
+#else
         if ( gopEntry.m_numActiveRefLayerPics != vps->getNumDirectRefLayers( getLayerId() ) )
+#endif
+#else
+        if ( gopEntry.m_numActiveRefLayerPics != vps->getNumDirectRefLayers( getLayerId() ) )
+#endif
         {        
           interLayerPredLayerIdcPresentFlag = true; 
@@ -941,5 +957,9 @@
     pcSlice->setRefPicList ( rcListPic );
 #endif
+#if !MTK_SINGLE_DEPTH_VPS_FLAG_J0060
 #if H_3D_SINGLE_DEPTH
+#if HHI_TOOL_PARAMETERS_I2_J0107
+    pcSlice->setApplySingleDepthMode( pcSlice->getIntraSingleFlag() );
+#else
     TEncTop* pcEncTop = (TEncTop*) m_pcCfg;
     bool enableSingleDepthMode=false;
@@ -952,5 +972,10 @@
     }
     pcSlice->setApplySingleDepthMode(enableSingleDepthMode);
-#endif    
+#endif
+#endif   
+#endif 
+#if SEC_ARP_VIEW_REF_CHECK_J0037 || SEC_DBBP_VIEW_REF_CHECK_J0037
+    pcSlice->setDefaultRefView();
+#endif
 #if H_3D_ARP
     //GT: This seems to be broken when layerId in vps is not equal to layerId in nuh
@@ -1414,8 +1439,12 @@
         pcSlice->getSPS()->getVuiParameters()->setHrdParametersPresentFlag( true );
       }
+#if HHI_TOOL_PARAMETERS_I2_J0107
+      m_pcEntropyCoder->encodeSPS(pcSlice->getSPS());
+#else
 #if !H_3D
       m_pcEntropyCoder->encodeSPS(pcSlice->getSPS());
 #else
       m_pcEntropyCoder->encodeSPS(pcSlice->getSPS(), pcSlice->getViewIndex(), pcSlice->getIsDepth() );
+#endif
 #endif
       writeRBSPTrailingBits(nalu.m_Bitstream);
Index: trunk/source/Lib/TLibEncoder/TEncSbac.cpp
===================================================================
--- trunk/source/Lib/TLibEncoder/TEncSbac.cpp	(revision 1085)
+++ trunk/source/Lib/TLibEncoder/TEncSbac.cpp	(revision 1124)
@@ -255,5 +255,9 @@
       curCost += m_CUTransquantBypassFlagSCModel.calcCost( curSliceType, qp, (UChar*)INIT_CU_TRANSQUANT_BYPASS_FLAG );
 #if H_3D_DIM
+#if HHI_TOOL_PARAMETERS_I2_J0107
+    if( m_pcSlice->getIntraSdcWedgeFlag() || m_pcSlice->getIntraContourFlag() )
+#else
     if( m_pcSlice->getVpsDepthModesFlag() || m_pcSlice->getIVPFlag() )
+#endif
     {
       curCost += m_cDepthIntraModeSCModel.calcCost    ( curSliceType, qp, (UChar*)INIT_DEPTH_INTRA_MODE );
@@ -346,8 +350,12 @@
 }
 
+#if HHI_TOOL_PARAMETERS_I2_J0107
+Void TEncSbac::codeSPS( TComSPS* pcSPS )
+#else
 #if H_3D
 Void TEncSbac::codeSPS( TComSPS* pcSPS, Int viewIndex, Bool depthFlag )
 #else
 Void TEncSbac::codeSPS( TComSPS* pcSPS )
+#endif
 #endif
 {
@@ -625,6 +633,10 @@
   PartSize eSize         = pcCU->getPartitionSize( uiAbsPartIdx );
 #if H_3D_QTLPC
+#if HHI_TOOL_PARAMETERS_I2_J0107
+  Bool    bLimQtPredFlag = pcCU->getPic()->getSlice(0)->getQtPredFlag();
+#else
   TComVPS *vps           = pcCU->getPic()->getSlice(0)->getVPS();
   Bool    bLimQtPredFlag = vps->getLimQtPredFlag(pcCU->getPic()->getSlice(0)->getLayerId());
+#endif
   TComPic *pcTexture     = pcCU->getSlice()->getTexturePic();
   Bool bDepthMapDetect   = (pcTexture != NULL);
@@ -998,6 +1010,11 @@
   Bool bCodeSplitFlag    = true;
 
+  
+#if HHI_TOOL_PARAMETERS_I2_J0107
+  Bool    bLimQtPredFlag = pcCU->getPic()->getSlice(0)->getQtPredFlag(); 
+#else
   TComVPS *vps           = pcCU->getPic()->getSlice(0)->getVPS();
   Bool    bLimQtPredFlag = vps->getLimQtPredFlag(pcCU->getPic()->getSlice(0)->getLayerId());
+#endif
   TComPic *pcTexture     = pcCU->getSlice()->getTexturePic();
   Bool bDepthMapDetect   = (pcTexture != NULL);
@@ -1060,5 +1077,9 @@
     dir[j] = pcCU->getLumaIntraDir( absPartIdx+partOffset*j );
 #if H_3D_DIM
+#if HHI_TOOL_PARAMETERS_I2_J0107
+    if( pcCU->getSlice()->getIntraSdcWedgeFlag() ||  pcCU->getSlice()->getIntraContourFlag() )
+#else
     if( pcCU->getSlice()->getVpsDepthModesFlag() ||  pcCU->getSlice()->getIVPFlag() )
+#endif
     {
       codeIntraDepth( pcCU, absPartIdx+partOffset*j );
@@ -1206,5 +1227,9 @@
     }
     //mode coding
+#if HHI_TOOL_PARAMETERS_I2_J0107
+    if( pcCU->getSlice()->getIntraSdcWedgeFlag() && pcCU->getSlice()->getIntraContourFlag())
+#else
     if( pcCU->getSlice()->getVpsDepthModesFlag() && pcCU->getSlice()->getIVPFlag())
+#endif
     {
       m_pcBinIf->encodeBin( uiCodeIdx == 0 ? 0 : 1, m_cDepthIntraModeSCModel.get( 0, 0, 0 ) );
@@ -2305,5 +2330,9 @@
   PartSize ePartSize = pcCU->getPartitionSize( uiAbsPartIdx );
   AOF( ePartSize == SIZE_2NxN || ePartSize == SIZE_Nx2N );
+#if HHI_TOOL_PARAMETERS_I2_J0107
+  AOF( pcCU->getSlice()->getDepthBasedBlkPartFlag() ); 
+#else
   AOF( pcCU->getSlice()->getVPS()->getUseDBBP(pcCU->getSlice()->getLayerIdInVps()) );
+#endif
   AOF( !pcCU->getSlice()->getIsDepth() );
   
